DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Focused Row

The TreeList component can highlight the focused row. To enable this feature, set the focusedRowEnabled property to true.

To focus a row programmatically, specify the focusedRowKey property. The TreeList automatically scrolls to the focused row. You can set the autoNavigateToFocusedRow property to false to deactivate this behavior. In the UI, users can click a row to focus it. The focused row is saved in the TreeList's state.

You can use the onFocusedRowChanging and onFocusedRowChanged properties to specify a custom function that is executed before or after a row is focused.

In this demo, the row with the 45 key is focused initially. You can specify the focusedRowKey property via the input field below the TreeList. The onFocusedRowChanged function is used to display additional information below the component when the focused row changes.

Backend API
$(() => { const url = 'https://js.devexpress.com/Demos/Mvc/api/TreeListTasks'; const taskEmployees = DevExpress.data.AspNet.createStore({ key: 'ID', loadMode: 'raw', loadUrl: `${url}/TaskEmployees`, }); const treeList = $('#treeList').dxTreeList({ dataSource: DevExpress.data.AspNet.createStore({ key: 'Task_ID', loadUrl: `${url}/Tasks`, onBeforeSend(_, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, }), remoteOperations: { filtering: true, sorting: true, grouping: true, }, parentIdExpr: 'Task_Parent_ID', hasItemsExpr: 'Has_Items', focusedRowEnabled: true, focusedRowKey: 45, showBorders: true, wordWrapEnabled: true, columns: [ { dataField: 'Task_ID', width: 100, alignment: 'left', }, { dataField: 'Task_Assigned_Employee_ID', caption: 'Assigned', minWidth: 120, lookup: { dataSource: taskEmployees, valueExpr: 'ID', displayExpr: 'Name', }, }, { dataField: 'Task_Status', caption: 'Status', width: 160, }, { dataField: 'Task_Start_Date', caption: 'Start Date', dataType: 'date', width: 160, }, { dataField: 'Task_Due_Date', caption: 'Due Date', dataType: 'date', width: 160, }, ], onFocusedRowChanged(e) { const rowData = e.row && e.row.data; let cellValue; let assigned; if (rowData) { cellValue = e.component.cellValue(e.row.rowIndex, 'Assigned'); taskEmployees.byKey(cellValue).done((item) => { assigned = item.Name; }); $('.task-subject').html(rowData.Task_Subject); $('.task-assigned').html(assigned); $('.start-date').html(new Date(rowData.Task_Start_Date).toLocaleDateString()); $('.task-status').html(rowData.Task_Status); const progress = rowData.Task_Completion ? `${rowData.Task_Completion}%` : ''; $('.task-progress').text(progress); } $('#taskId').dxNumberBox('instance').option('value', treeList.option('focusedRowKey')); }, }).dxTreeList('instance'); $('#taskId').dxNumberBox({ min: 1, max: 182, step: 0, inputAttr: { 'aria-label': 'Focused Row Key' }, onValueChanged(e) { if (e.event && e.value > 0) { treeList.option('focusedRowKey', e.value); } }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="https://unpkg.com/devextreme-aspnet-data@3.0.0/js/dx.aspnet.data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="treeList"></div> <div class="task-info"> <div class="info"> <div class="task-subject"></div> <span class="task-assigned"></span> <span class="start-date"></span> </div> <div class="progress"> <span class="task-status"></span> <span class="task-progress"></span> </div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Focused row key</span> <div id="taskId"></div> </div> </div> </div> </body> </html>
#treeList { max-height: 400px; } .task-info { font-family: Segoe UI; min-height: 100px; display: flex; flex-wrap: nowrap; border: 2px solid rgba(0, 0, 0, 0.1); padding: 16px; box-sizing: border-box; align-items: center; justify-content: space-between; } .info { display: flex; flex-direction: column; } .task-subject { line-height: 29px; font-size: 18px; font-weight: bold; } .progress { display: flex; flex-direction: column; white-space: pre; min-width: 105px; } .task-progress { line-height: 42px; font-size: 40px; font-weight: bold; } .options { margin-top: 20px; padding: 20px; background-color: rgba(191, 191, 191, 0.15); position: relative; } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; } .option > .dx-numberbox { width: 200px; display: inline-block; vertical-align: middle; } .option > span { margin-right: 10px; }

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<template>
<div>
<DxTreeList
id="treeList"
:data-source="dataSource"
:word-wrap-enabled="true"
:show-borders="true"
:focused-row-enabled="true"
v-model:focused-row-key="focusedRowKey"
parent-id-expr="Task_Parent_ID"
has-items-expr="Has_Items"
@focused-row-changed="onFocusedRowChanged"
>
<DxColumn
data-field="Task_ID"
width="100"
alignment="left"
/>
<DxColumn
:min-width="120"
data-field="Task_Assigned_Employee_ID"
caption="Assigned"
>
<DxLookup
:data-source="taskEmployees"
value-expr="ID"
display-expr="Name"
/>
</DxColumn>
<DxColumn
data-field="Task_Status"
caption="Status"
width="160"
/>
<DxColumn
data-field="Task_Start_Date"
caption="Start Date"
data-type="date"
width="160"
/>
<DxColumn
data-field="Task_Due_Date"
caption="Due Date"
data-type="date"
width="160"
/>
</DxTreeList>
<div class="task-info">
<div class="info">
<div class="task-subject">{{ taskSubject }}</div>
<span class="task-assigned">{{ taskAssigned }}</span>
<span class="start-date">{{ startDate }}</span>
</div>
<div class="progress">
<span class="task-status">{{ taskStatus }}</span>
<span class="task-progress">{{ taskProgress }}</span>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Focused row key </span>
<DxNumberBox
id="taskId"
:min="1"
:max="182"
:step="0"
v-model:value="focusedRowKey"
:input-attr="{ 'aria-label': 'Focused Row Key' }"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxTreeList, DxColumn, DxLookup, DxTreeListTypes,
} from 'devextreme-vue/tree-list';
import DxNumberBox from 'devextreme-vue/number-box';
import { createStore } from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/Mvc/api/TreeListTasks';
const taskSubject = ref('');
const taskAssigned = ref('');
const startDate = ref('');
const taskStatus = ref('');
const taskProgress = ref('');
const dataSource = createStore({
key: 'Task_ID',
loadUrl: `${url}/Tasks`,
onBeforeSend(_, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const taskEmployees = createStore({
key: 'ID',
loadMode: 'raw',
loadUrl: `${url}/TaskEmployees`,
});
const focusedRowKey = ref(45);
function onFocusedRowChanged(e: DxTreeListTypes.FocusedCellChangedEvent) {
const rowData = e.row && e.row.data;
let cellValue;
let assigned;
if (rowData) {
cellValue = e.component.cellValue(e.row.rowIndex, 'Assigned');
taskEmployees.byKey(cellValue).done((item) => {
assigned = item.Name;
});
taskSubject.value = rowData.Task_Subject;
taskAssigned.value = assigned;
startDate.value = new Date(rowData.Task_Start_Date).toLocaleDateString();
taskStatus.value = rowData.Task_Status;
taskProgress.value = rowData.Task_Completion
? `${rowData.Task_Completion}%`
: '';
}
}
</script>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://unpkg.com/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@3.0.0/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.5/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.54/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
#treeList {
max-height: 400px;
}
.task-info {
font-family: "Segoe UI";
min-height: 100px;
display: flex;
flex-wrap: nowrap;
border: 2px solid rgba(0, 0, 0, 0.1);
padding: 16px;
box-sizing: border-box;
align-items: center;
justify-content: space-between;
}
.info {
display: flex;
flex-direction: column;
}
.task-subject {
line-height: 29px;
font-size: 18px;
font-weight: bold;
}
.progress {
display: flex;
flex-direction: column;
white-space: pre;
min-width: 105px;
}
.task-progress {
line-height: 42px;
font-size: 40px;
font-weight: bold;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > .dx-numberbox {
width: 200px;
display: inline-block;
vertical-align: middle;
}
.option > span {
margin-right: 10px;
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/typescript@5.4.5/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://unpkg.com/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
In this demo, the row with the 45
key is focused initially. You can specify the focusedRowKey
property via the input field below the TreeList. The onFocusedRowChanged function is used to display additional information below the component when the focused row changes.

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Focused Row

The TreeList component can highlight the focused row. To enable this feature, set the focusedRowEnabled property to true.

To focus a row programmatically, specify the focusedRowKey property. The TreeList automatically scrolls to the focused row. You can set the autoNavigateToFocusedRow property to false to deactivate this behavior. In the UI, users can click a row to focus it. The focused row is saved in the TreeList's state.

You can use the onFocusedRowChanging and onFocusedRowChanged properties to specify a custom function that is executed before or after a row is focused.

In this demo, the row with the 45 key is focused initially. You can specify the focusedRowKey property via the input field below the TreeList. The onFocusedRowChanged function is used to display additional information below the component when the focused row changes.

Backend API
<dx-tree-list id="treeList" [dataSource]="dataSource" parentIdExpr="Task_Parent_ID" wordWrapEnabled="true" showBorders="true" focusedRowEnabled="true" hasItemsExpr="Has_Items" [(focusedRowKey)]="focusedRowKey" (onFocusedRowChanged)="onFocusedRowChanged($event)" > <dxo-remote-operations [filtering]="true" [sorting]="true" [grouping]="true" ></dxo-remote-operations> <dxi-column dataField="Task_ID" width="100" alignment="left"></dxi-column> <dxi-column dataField="Task_Assigned_Employee_ID" caption="Assigned" minWidth="120" > <dxo-lookup [dataSource]="taskEmployees" valueExpr="ID" displayExpr="Name" ></dxo-lookup> </dxi-column> <dxi-column dataField="Task_Status" caption="Status" width="160"></dxi-column> <dxi-column dataField="Task_Start_Date" caption="Start Date" dataType="date" width="160" ></dxi-column> <dxi-column dataField="Task_Due_Date" caption="Due Date" dataType="date" width="160" ></dxi-column> </dx-tree-list> <div class="task-info"> <div class="info"> <div class="task-subject">{{ taskSubject }}</div> <span class="task-assigned">{{ taskAssigned }}</span> <span class="start-date">{{ startDate }}</span> </div> <div class="progress"> <span class="task-status">{{ taskStatus }}</span> <span class="task-progress">{{ taskProgress }}</span> </div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Focused row key</span> <dx-number-box id="taskId" min="1" max="182" step="0" [(value)]="focusedRowKey" [inputAttr]="{ 'aria-label': 'Focused Row Key' }" > </dx-number-box> </div> </div>
import { NgModule, Component, enableProdMode } from '@angular/core'; import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import * as AspNetData from 'devextreme-aspnet-data-nojquery'; import { DxNumberBoxModule } from 'devextreme-angular'; import { DxTreeListModule, DxTreeListTypes } from 'devextreme-angular/ui/tree-list'; if (!/localhost/.test(document.location.host)) { enableProdMode(); } declare var __moduleName: string; const url = 'https://js.devexpress.com/Demos/Mvc/api/TreeListTasks'; @Component({ selector: 'demo-app', templateUrl: 'app.component.html', styleUrls: ['app.component.css'], moduleId: __moduleName, preserveWhitespaces: true, }) export class AppComponent { taskSubject: string; taskAssigned: string; startDate: string; taskStatus: string; taskProgress: string; focusedRowKey = 45; dataSource = AspNetData.createStore({ key: 'Task_ID', loadUrl: `${url}/Tasks`, onBeforeSend(_, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, }); taskEmployees = AspNetData.createStore({ key: 'ID', loadMode: 'raw', loadUrl: `${url}/TaskEmployees`, }); onFocusedRowChanged(e: DxTreeListTypes.FocusedRowChangedEvent) { const rowData = e.row && e.row.data; let cellValue: unknown; let assigned: string; if (rowData) { cellValue = e.component.cellValue(e.row.rowIndex, 'Assigned'); this.taskEmployees.byKey(cellValue).done(({ Name }) => { assigned = Name; }); this.taskSubject = rowData.Task_Subject; this.taskAssigned = assigned; this.startDate = new Date(rowData.Task_Start_Date).toLocaleDateString(); this.taskStatus = rowData.Task_Status; this.taskProgress = rowData.Task_Completion ? `${rowData.Task_Completion}%` : ''; } } } @NgModule({ imports: [ BrowserModule, BrowserTransferStateModule, DxTreeListModule, DxNumberBoxModule, ], declarations: [AppComponent], bootstrap: [AppComponent], }) export class AppModule { } platformBrowserDynamic().bootstrapModule(AppModule);
#treeList { max-height: 400px; } .task-info { font-family: Segoe UI; min-height: 100px; display: flex; flex-wrap: nowrap; border: 2px solid rgba(0, 0, 0, 0.1); padding: 16px; box-sizing: border-box; align-items: center; justify-content: space-between; } .info { display: flex; flex-direction: column; } .task-subject { line-height: 29px; font-size: 18px; font-weight: bold; } .progress { display: flex; flex-direction: column; white-space: pre; min-width: 105px; } .task-progress { line-height: 42px; font-size: 40px; font-weight: bold; } .options { margin-top: 20px; padding: 20px; background-color: rgba(191, 191, 191, 0.15); position: relative; } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; } .option > .dx-numberbox { width: 200px; display: inline-block; vertical-align: middle; } .option > span { margin-right: 10px; }
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, }, meta: { 'typescript': { 'exports': 'ts', }, 'devextreme-aspnet-data-nojquery': { 'esModule': true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', '@angular/core': 'npm:@angular/core@12.2.17', '@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17', '@angular/forms': 'npm:@angular/forms@12.2.17', '@angular/common': 'npm:@angular/common@12.2.17', '@angular/compiler': 'npm:@angular/compiler@12.2.17', 'tslib': 'npm:tslib@2.6.2/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@3.0.0/index.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.6/cjs', 'devextreme/bundles/dx.all': 'npm:devextreme@23.2.6/bundles/dx.all.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.54', 'devextreme-angular': 'npm:devextreme-angular@23.2.6', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', 'npm:@angular/*/package.json', 'npm:@angular/common@12.2.17/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devextreme-angular@23.2.6/*/package.json', 'npm:devextreme-angular@23.2.6/ui/*/package.json', 'npm:devextreme-angular@23.2.6/package.json', 'npm:devexpress-diagram@2.2.5/package.json', 'npm:devexpress-gantt@4.1.54/package.json', ], }; System.config(window.config);
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script> <script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>

-
Data Grid
- Overview
-
Data Binding
-
Paging and Scrolling
-
Editing
-
Grouping
-
Filtering and Sorting
- Focused Row
-
Row Drag & Drop
-
Selection
-
Columns
- State Persistence
-
Appearance
-
Templates
-
Data Summaries
-
Master-Detail
-
Export to PDF
-
Export to Excel
-
Adaptability
- Keyboard Navigation
-
Pivot Grid
- Overview
-
Data Binding
-
Field Chooser
-
Features
-
Export to Excel
-
Tree List
- Overview
-
Data Binding
- Sorting
- Paging
-
Editing
- Node Drag & Drop
- Focused Row
-
Selection
-
Filtering
-
Column Customization
- State Persistence
- Adaptability
- Keyboard Navigation
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Features
- Virtual Scrolling
-
Grouping
-
Customization
- Adaptability
-
Html Editor
-
Chat
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
Charts
- Overview
-
Data Binding
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Line Charts
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
-
Sparkline Charts
-
Tree Map
-
Funnel and Pyramid Charts
- Sankey Chart
-
Combinations
-
More Features
-
Export
-
Selection
-
Tooltips
-
Zooming
-
-
Gantt
- Overview
-
Data
-
UI Customization
- Strip Lines
- Export to PDF
- Sorting
-
Filtering
-
Gauges
- Overview
-
Data Binding
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Navigation
- Overview
- Accordion
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
- Pagination
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
- Resizable
-
-
Editors
- Overview
- Autocomplete
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Drop Down Box
-
Number Box
-
Select Box
- Switch
-
Tag Box
- Text Area
- Text Box
- Validation
- Custom Text Editor Buttons
- Right-to-Left Support
- Editor Appearance Variants
-
Forms and Multi-Purpose
- Overview
- Button Group
- Field Set
-
Filter Builder
-
Form
- Radio Group
-
Range Selector
- Numeric Scale (Lightweight)
- Numeric Scale
- Date-Time Scale (Lightweight)
- Date-Time Scale
- Logarithmic Scale
- Discrete scale
- Custom Formatting
- Use Range Selection for Calculation
- Use Range Selection for Filtering
- Image on Background
- Chart on Background
- Customized Chart on Background
- Chart on Background with Series Template
- Range Slider
- Slider
-
Sortable
-
File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Actions and Lists
- Overview
-
Action Sheet
-
Button
- Floating Action Button
- Drop Down Button
-
Context Menu
-
List
-
Lookup
-
Maps
- Overview
-
Map
-
Vector Map
-
Dialogs and Notifications
-
Localization
React Tree List - Focused Row
The TreeList component can highlight the focused row. To enable this feature, set the focusedRowEnabled property to true.
To focus a row programmatically, specify the focusedRowKey property. The TreeList automatically scrolls to the focused row. You can set the autoNavigateToFocusedRow property to false to deactivate this behavior. In the UI, users can click a row to focus it. The focused row is saved in the TreeList's state.
You can use the onFocusedRowChanging and onFocusedRowChanged properties to specify a custom function that is executed before or after a row is focused.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
import React, { useCallback, useState } from 'react';
import TreeList, { Column, Lookup, TreeListTypes } from 'devextreme-react/tree-list';
import { NumberBox, NumberBoxTypes } from 'devextreme-react/number-box';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/Mvc/api/TreeListTasks';
const dataSourceOptions = AspNetData.createStore({
key: 'Task_ID',
loadUrl: `${url}/Tasks`,
onBeforeSend(_, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const taskEmployees = AspNetData.createStore({
key: 'ID',
loadMode: 'raw',
loadUrl: `${url}/TaskEmployees`,
});
const focusedRowKeyLabel = { 'aria-label': 'Focused Row Key' };
const App = () => {
const [taskSubject, setTaskSubject] = useState('');
const [taskAssigned, setTaskAssigned] = useState('');
const [startDate, setStartDate] = useState('');
const [taskStatus, setTaskStatus] = useState('');
const [taskProgress, setTaskProgress] = useState('');
const [focusedRowKey, setFocusedRowKey] = useState(45);
const onTaskIdChanged = useCallback((e: NumberBoxTypes.ValueChangedEvent) => {
if (e.event && e.value > 0) {
setFocusedRowKey(e.value);
}
}, []);
const onFocusedRowChanged = useCallback(async(e: TreeListTypes.FocusedRowChangedEvent) => {
const rowData = e.row && e.row.data;
if (rowData) {
const progress = rowData.Task_Completion ? `${rowData.Task_Completion}%` : '';
const cellValue = e.component.cellValue(e.row.rowIndex, 'Assigned');
const item = await taskEmployees.byKey(cellValue);
setTaskSubject(rowData.Task_Subject);
setTaskAssigned(item.Name);
setStartDate(new Date(rowData.Task_Start_Date).toLocaleDateString());
setTaskStatus(e.row.data.Task_Status);
setTaskProgress(progress);
setFocusedRowKey(e.component.option('focusedRowKey'));
}
}, []);
return (
<div>
<TreeList
id="treeList"
dataSource={dataSourceOptions}
focusedRowEnabled={true}
focusedRowKey={focusedRowKey}
parentIdExpr="Task_Parent_ID"
hasItemsExpr="Has_Items"
wordWrapEnabled={true}
showBorders={true}
onFocusedRowChanged={onFocusedRowChanged}>
<Column dataField="Task_ID" width={100} alignment="left" />
<Column dataField="Task_Assigned_Employee_ID" caption="Assigned" minWidth={120}>
<Lookup dataSource={taskEmployees} valueExpr="ID" displayExpr="Name" />
</Column>
<Column dataField="Task_Status" caption="Status" width={160} />
<Column dataField="Task_Start_Date" caption="Start Date" dataType="date" width={160} />
<Column dataField="Task_Due_Date" caption="Due Date" dataType="date" width={160} />
</TreeList>
<div className="task-info">
<div className="info">
<div className="task-subject">{taskSubject}</div>
<span className="task-assigned">{taskAssigned}</span>
<span className="start-date">{startDate}</span>
</div>
<div className="progress">
<span className="task-status">{taskStatus}</span>
<span className="task-progress">{taskProgress}</span>
</div>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Focused row key </span>
<NumberBox
id="taskId"
min={1}
max={182}
step={0}
value={focusedRowKey}
inputAttr={focusedRowKeyLabel}
onValueChanged={onTaskIdChanged}>
</NumberBox>
</div>
</div>
</div>
);
};
export default App;
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
In this demo, the row with the 45
key is focused initially. You can specify the focusedRowKey
property via the input field below the TreeList. The onFocusedRowChanged function is used to display additional information below the component when the focused row changes.